
    var lpcount,lrcount,rpcount,rrcount,deltax,deltay,lhcount,rhcount:integer;
        lpoldcur,lroldcur,rpoldcur,rroldcur:tintvector2d;
        leftedge,rightedge,gvs:boolean;
        n:word;
        dbrickswitch:byte;

    procedure MouseControler;
      {zabezpecuje ovladanie mysou}

      procedure TurnIconTest(x1,y1,x2,y2:integer; n1,n2:byte;
                             var turnangle:single; step:single);
        {ak je mcur v okne <x1,y1>x<x2,y2>, zvyrazni n1. sipku, ak je na nej
         stlacene mysitko, zvyrazni ju inac a k turnangle prida step,
         ak je prevratene ovladanie (bonus 28) inac zvyrazni n2. sipku}
        begin
          if (mcur.x>=x1) and (mcur.y>=y1) and
             (mcur.x<=x2) and (mcur.y<=y2) then
            begin
              icolblue:=n1;
              if (left in mstate) or (right in mstate)(*and
                 (lpoldcur.x>=x1) and (lpoldcur.y>=y1) and
                 (lpoldcur.x<=x2) and (lpoldcur.y<=y2)*) then
                   begin
                     if _28=0 then
                       begin icolred:=n1; turnangle:=turnangle+step; end
                     else
                       begin icolred:=n2; turnangle:=turnangle-step; end;
                   end;
            end;
        end;

      procedure GravIconTest(x1,y1,x2,y2:integer; grv1,grv2:tcubeplanes);
        {ak je mcur v okne <x1,x2>x<y1,y2>, bolo uvolnene mysitko, ktore bolo
         predtym stlacene v tomto okne invertuj gravitaciu grv1, ak je
         prevratene ovladanie (bonus 28) tak grv2}
         begin
           if (mcur.x>=x1) and (mcur.y>=y1) and
              (mcur.x<=x2) and (mcur.y<=y2) then
             if (not (left in mstate)) and Odd(lrcount) and
               (lpoldcur.x>=x1) and (lpoldcur.y>=y1) and
               (lpoldcur.x<=x2) and (lpoldcur.y<=y2) or
               (not (right in mstate)) and Odd(rrcount) and
               (rpoldcur.x>=x1) and (rpoldcur.y>=y1) and
               (rpoldcur.x<=x2) and (rpoldcur.y<=y2) then
              if _28=0 then InvertGravity(grv1)
              else InvertGravity(grv2);
         end;

      function InPlane(plane:tcubeplanes):boolean;
        {zisti ci je kurzor mysi vnutri priemetu plochy plane}

        function InVertices(v1,v2,v3,v4:integer):boolean;
          {zisti ci je kurzor mysi vnutri plochy urcenej
           projroomvertices[v1..v4]}

          procedure Intersect(vv1,vv2:integer);
            {podla x suradnice priesecnika usecky vv1,vv2 a vodorovnej cez
             mcur pripadne nastavi leftedge alebo rightedge na true}
             begin
               if Sgn(mcur.y-projroomvertices[vv1].y)<>
                  Sgn(mcur.y-projroomvertices[vv2].y) then
                 if (projroomvertices[vv2].x-projroomvertices[vv1].x)/
                    (projroomvertices[vv2].y-projroomvertices[vv1].y)*
                    (mcur.y-projroomvertices[vv1].y)+
                    projroomvertices[vv1].x<mcur.x then leftedge:=true
                 else rightedge:=true;
             end;

          begin
            leftedge:=false; rightedge:=false;
            Intersect(v1,v2);
            Intersect(v2,v3);
            Intersect(v3,v4);
            Intersect(v4,v1);
            InVertices:=leftedge and rightedge;
          end;

        begin
          case plane of
            leftp:  InPlane:=InVertices(0,3,7,4);
            rightp: InPlane:=InVertices(1,5,6,2);
            upp:    InPlane:=InVertices(0,1,2,3);
            downp:  InPlane:=InVertices(7,6,5,4);
            nearp:  InPlane:=InVertices(0,4,5,1);
            farp:   InPlane:=InVertices(7,3,2,6);
          end;
        end;

      begin
        {zisti kde boli mysitka naposledy stlacene a uvolnene a kolkokrat}
        TestPressedButton(left,mstate,lpcount,lpoldcur);
        TestReleasedButton(left,mstate,lrcount,lroldcur);
        TestPressedButton(right,mstate,rpcount,rpoldcur);
        TestReleasedButton(right,mstate,rrcount,rroldcur);
        {co je stlacene teraz a kde je kurzor}
        TestMouseState;
        icolblue:=0; icolred:=0;
        SetGraphCursorType2(cgArrow2);

        {ak je kurzor v okne miestnosti}
        if (mcur.x>=60) and (mcur.y>=3) and
           (mcur.x<=260) and (mcur.y<=163) then
          if (left in mstate) or (right in mstate) then  {je nieco stlacene}
            begin
              GetRelativeMove(deltax,deltay);
              if (left in mstate) and (lhcount>0) or
                 (right in mstate) and (rhcount>0) then      {ak dragging}
                begin
                  if _28=0 then
                    begin
                      xturn:=xturn+deltay/100; yturn:=yturn+deltax/100;
                    end
                  else
                    begin
                      xturn:=xturn-deltay/100; yturn:=yturn-deltax/100;
                    end;
                  if Abs(xturn)>Abs(yturn) then
                    if xturn>0 then
                      begin
                        SetGraphCursorType2(cgDownArrow2); icolred:=4;
                      end
                    else
                      begin
                        SetGraphCursorType2(cgUpArrow2); icolred:=3;
                      end
                  else
                    if yturn>0 then
                      begin
                        SetGraphCursorType2(cgRightArrow2); icolred:=1;
                      end
                    else
                      if yturn<0 then
                        begin
                          SetGraphCursorType2(cgLeftArrow2); icolred:=2;
                        end
                end;
              if left in mstate then Inc(lhcount);
              if right in mstate then Inc(rhcount);
            end
          else          {ak je v okne a nic nie je stlacene}
            begin
              if Odd(lrcount) and (lhcount<3) or
                 Odd(rrcount) and (rhcount<3) then
                begin
                  if Odd(lrcount) and (lhcount<3) then gvs:=true
                  else gvs:=false;
                  if InPlane(leftp) and (VisiblePlane(leftp,0)=gvs) then
                    if _28=0 then InvertGravity(leftp)
                    else InvertGravity(rightp);
                  if InPlane(rightp) and (VisiblePlane(rightp,7*49-1)=gvs) then
                    if _28=0 then InvertGravity(rightp)
                    else InvertGravity(leftp);
                  if InPlane(upp) and (VisiblePlane(upp,0)=gvs) then
                    if _28=0 then InvertGravity(upp)
                    else InvertGravity(downp);
                  if InPlane(downp) and (VisiblePlane(downp,7*49-1)=gvs) then
                    if _28=0 then InvertGravity(downp)
                    else InvertGravity(upp);
                  if InPlane(nearp) and (VisiblePlane(nearp,0)=gvs) then
                    if _28=0 then InvertGravity(nearp)
                    else InvertGravity(farp);
                  if InPlane(farp) and (VisiblePlane(farp,7*49-1)=gvs) then
                    if _28=0 then InvertGravity(farp)
                    else InvertGravity(nearp);
                end;
              lhcount:=0; rhcount:=0;
            end
        else
          begin
            lhcount:=0; rhcount:=0;
          end;

        TurnIconTest(9,169,24,180,1,2,yturn,stepangle);
        TurnIconTest(8,181,23,192,2,1,yturn,-stepangle);
        TurnIconTest(37,172,48,187,3,4,xturn,-stepangle);
        TurnIconTest(49,172,60,187,4,3,xturn,stepangle);
        TurnIconTest(69,170,84,176,5,6,zturn,-stepangle);
        TurnIconTest(69,177,76,185,5,6,zturn,-stepangle);
        TurnIconTest(75,185,90,191,6,5,zturn,stepangle);
        TurnIconTest(83,177,90,184,6,5,zturn,stepangle);

        GravIconTest(128,173,159,193,leftp,rightp);
        GravIconTest(160,173,195,193,rightp,leftp);
        GravIconTest(196,173,223,193,upp,downp);
        GravIconTest(224,173,255,193,downp,upp);
        GravIconTest(256,173,287,193,nearp,farp);
        GravIconTest(288,173,319,193,farp,nearp);

        if (mcur.x>=23) and (mcur.y>=140) and
           (mcur.x<=59) and (mcur.y<=158) then
          if (not (left in mstate)) and Odd(lrcount) and
            (lpoldcur.x>=23) and (lpoldcur.y>=140) and
            (lpoldcur.x<=59) and (lpoldcur.y<=158) or
            (not (right in mstate)) and Odd(rrcount) and
            (rpoldcur.x>=23) and (rpoldcur.y>=140) and
            (rpoldcur.x<=59) and (rpoldcur.y<=158) then
            if _eye<200 then _eye:=200
            else if (_eye>206) and (_eye<=211) then _eye:=212-_eye+200;

      end;



  procedure BonusControler;
    {ovlada casovane bonusy}
    var deltaz:single;
    begin
      if _4>0 then Dec(_4);

      if _5>0 then Dec(_5);

      if (_6>0) or (roomcenter.z>rcdist) then
        begin
          if _6>0 then
            begin deltaz:=7; Dec(_6); end
          else deltaz:=-7;
          roomcenter.z:=roomcenter.z+deltaz;
          minusroomcenter.z:=-roomcenter.z;
          transfroomvertices[0].z:=transfroomvertices[0].z+deltaz;
          transfroomvertices[1].z:=transfroomvertices[1].z+deltaz;
          transfroomvertices[2].z:=transfroomvertices[2].z+deltaz;
          transfroomvertices[3].z:=transfroomvertices[3].z+deltaz;
          transfroomvertices[4].z:=transfroomvertices[4].z+deltaz;
          transfroomvertices[5].z:=transfroomvertices[5].z+deltaz;
          transfroomvertices[6].z:=transfroomvertices[6].z+deltaz;
          transfroomvertices[7].z:=transfroomvertices[7].z+deltaz;
          transfball.z:=transfball.z+deltaz;
        end;

      if _7>0 then
        begin xturn:=xturn+stepangle; Dec(_7); end;

      if _8>1 then
        begin
          if ballradius>1 then Dec(ballradius);
          Dec(_8);
        end;
      if _8=1 then
        if ballradius<ballradiusbak then
          if (Abs(ball.x+roomedge/2)>ballradius+1) and
             (Abs(ball.x-roomedge/2)>ballradius+1) and
             (Abs(ball.y+roomedge/2)>ballradius+1) and
             (Abs(ball.y-roomedge/2)>ballradius+1) and
             (Abs(ball.z+roomedge/2)>ballradius+1) and
             (Abs(ball.z-roomedge/2)>ballradius+1) then Inc(ballradius)
          else
        else Dec(_8);

      if _9>0 then
        begin yturn:=yturn+stepangle; Dec(_9); end;

      if _10>0 then
        begin zturn:=zturn+stepangle; Dec(_10); end;

      if _12>1 then Dec(_12);
      if _12=1 then
        if (Abs(ball.x+roomedge/2)>ballradius) and
           (Abs(ball.x-roomedge/2)>ballradius) and
           (Abs(ball.y+roomedge/2)>ballradius) and
           (Abs(ball.y-roomedge/2)>ballradius) and
           (Abs(ball.z+roomedge/2)>ballradius) and
           (Abs(ball.z-roomedge/2)>ballradius) then Dec(_12);

      if _14>1 then Dec(_14);
      if _14=1 then
        begin ro:=robak; Dec(_14); end;

      if _15>0 then Dec(_15);

      if _16>0 then Dec(_16);

      if _18>0 then Dec(_18);

      if _19>0 then Dec(_19);

      if _20>1 then Dec(_20);
      if _20=1 then
        begin ro:=robak; Dec(_20); end;

      if _21>1 then
        begin
          if ballradius<16 then
            if (Abs(ball.x+roomedge/2)>ballradius+1) and
               (Abs(ball.x-roomedge/2)>ballradius+1) and
               (Abs(ball.y+roomedge/2)>ballradius+1) and
               (Abs(ball.y-roomedge/2)>ballradius+1) and
               (Abs(ball.z+roomedge/2)>ballradius+1) and
               (Abs(ball.z-roomedge/2)>ballradius+1) then Inc(ballradius);
          Dec(_21);
        end;
      if _21=1 then
        if ballradius>ballradiusbak then Dec(ballradius)
        else Dec(_21);

      if _23>0 then Dec(_23);

      if _28>0 then Dec(_28);

      if _30>0 then Dec(_30);
    end;


  const rec:array[0..5] of tintvector=(
          (x: 0; y: 0; z:-1),
          (x: 0; y: 1; z: 0),
          (x: 0; y: 0; z: 1),
          (x: 0; y:-1; z: 0),
          (x:-1; y: 0; z: 0),
          (x: 1; y: 0; z: 0));

  procedure FindRandomEnvCube(var ri,rj,rk:integer);
    {vyberie nahodnu z okolitych volnych kociek}
    var idx,idx0,count:integer;

    function CubeAccepted(ci,cj,ck:byte):boolean;
      {zisti ci je kocka dnu v miestnosti a nie je v nej tehla}
      begin
        CubeAccepted:=(ci in [0..5]) and (cj in [0..5]) and (ck in [0..5])
                      and (bricks[ci,cj,ck]<$C0);
      end;

    begin
      idx0:=Random(6);
      count:=0;
      repeat
        idx:=(idx0+count) mod 6;
        Inc(count);
      until (count>6) or
            CubeAccepted(ri+rec[idx].z,rj+rec[idx].y,rk+rec[idx].x);
      if count<=6 then
        begin
          ri:=ri+rec[idx].z; rj:=rj+rec[idx].y; rk:=rk+rec[idx].x;
        end
      else ri:=-1;
    end;


  procedure BricksControler;
    {ovlada anomalie tehal}
    var i,j,k,btype:byte;
        ri,rj,rk:integer;
    begin
      Inc(_bricks);
      if _bricks mod 10=0 then
        begin
          for i:=0 to 5 do
            for j:=0 to 5 do
              for k:=0 to 5 do
                begin
                  btype:=bricks[i,j,k];

                  if (btype and $DF)=dbrickswitch then
                    begin
                      ri:=i; rj:=j; rk:=k;
                      FindRandomEnvCube(ri,rj,rk);
                      if ri<>-1 then
                        begin
                          bricks[ri,rj,rk]:=bricks[i,j,k] xor $10;
                          brickscolors[ri,rj,rk]:=brickscolors[i,j,k];
                          bricks[i,j,k]:=0;
                        end;
                    end

                  else if (_bricks mod 200=100) and ((btype and $8F)=$E) then
                         begin
                           bricks[i,j,k]:=bricks[i,j,k] or $C0;
                           Inc(bricksnb);
                         end

                  else if (_bricks mod 200=0) then
                         if (btype and $CF)=$CF then
                           begin
                             ri:=i; rj:=j; rk:=k;
                             FindRandomEnvCube(ri,rj,rk);
                             if ri<>-1 then
                               begin
                                 bricks[ri,rj,rk]:=bricks[i,j,k] and $F1;
                                 brickscolors[ri,rj,rk]:=brickscolors[i,j,k];
                                 Inc(bricksnb);
                               end;
                           end;

                end;
          dbrickswitch:=dbrickswitch xor $10;
        end;
    end;


  procedure EyeControler;
    {ovlada pohyby oka}
    begin
      Inc(_eye);
      if (_eye<200) then
        begin
          if (_eye mod 20=0) then eyeview:=Random(7);
          if eyeview<=4 then eyespr:=6;
          if eyeview=5 then
            begin
              eyespr:=6;
              if _eye mod 20<18 then eyespr:=14;
              if _eye mod 20<10 then eyespr:=6;
              if _eye mod 20<8 then eyespr:=13;
            end;
          if eyeview=6 then
            begin
              eyespr:=6;
              if _eye mod 20<18 then eyespr:=13;
              if _eye mod 20<10 then eyespr:=6;
              if _eye mod 20<8 then eyespr:=14;
            end;
          if not ballin then _eye:=211;
        end
      else
        if _eye<=206 then eyespr:=_eye-200+6
        else if _eye<=211 then eyespr:=211-_eye+7
        else if ballin then _eye:=0
        else if _eye<=221 then eyespr:=(_eye-212) shr 1+15
        else
          begin _eye:=222; eyespr:=19; end;
    end;



  var oldint1Ch:pointer;

  {F+} {$S-}
  procedure Intr1ChHandler; interrupt;
    {obsluha prerusenia 1Ch pod casovacom}
    begin
      if not paused then
        begin
          if mpresent then MouseControler;
          BonusControler;
          BricksControler;
        end;
      EyeControler;

      asm
        call    dword ptr[oldint1Ch]
      end;
    end;
  {$F-}


  procedure HookIntr1Ch;
    {zavesi proceduru Intr1ChHandler na uzivatelsky interrupt casovaca (1Ch)
     na jej konci vola aj povodne int 1Ch}
    begin
      GetIntVec($1C,oldint1Ch);
      SetIntVec($1C,Addr(Intr1ChHandler));
    end;


  procedure ReleaseIntr1Ch;
    {odstrani volanie Intr1ChHandler z interruptu 1Ch a vrati tam volanie
     ake bolo pred vykonanim HookIntr1Ch}
    begin
      SetIntVec($1C,oldint1Ch);
    end;
